/*****************************************************************************\
**     Killer Cracker v7.00 - Un*x Password Cracker - By Doctor Dissector    **
** ========================================================================= **
**      Filename: kc.c  -  Last update: 06/01/91  -  Copyright (c) 1991      **
\*****************************************************************************/

/*
** Killer Cracker - Version 7.00
** Copyright (C) 1991 By Doctor Dissector
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 1, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*=[ Copyright ]=============================================================*/

char kc_c_msg[]="Source: kc.c, Copyright (c)1991 Doctor Dissector";

/*=[ Include KC Header File ]================================================*/

#include "kc.h"

/*=[ General Header Files ]==================================================*/

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <errno.h>

#ifndef __ANSI
#include <signal.h>
#endif

#if defined(__MSDOS)
#include <sys\types.h>
#endif

#if defined(__UNIX)
#include <sys/types.h>
#endif

#if defined(__TURBO)
#include <alloc.h>
#endif

#if defined(__MICROSOFT)
#include <malloc.h>
#endif

#if defined(__ANSI)
#include <stdlib.h>
#endif

#if defined(__BSD)
#include <sys/time.h>
#include <sys/resource.h>
#endif

/*=[ Global Variables ]======================================================*/

kc_struct       *kc;                            /* General data structure */

FILE            *vf,                            /* Valid account file stream */
                *gf;                            /* Word guess file stream */

time_t          timer;                          /* Execution timing variable */

unsigned long   combinations;                   /* Total comparisions */

char            passwordfile[MAX_FILENAME],     /* Passwordfile filename */
                wordfile[MAX_FILENAME],         /* Word guess filename */
                validfile[MAX_FILENAME],        /* Valid account filename */
                restorefile[MAX_FILENAME],      /* Restore file filename */
                progname[MAX_FILENAME],         /* KC's currnet process name */
                errorcode[81],                  /* Exit description */
                lastword[41],                   /* Last word cracked */
                r_word[41],                     /* Restore last word */
                r_account[13];                  /* Restore last account */

int             cracktype,                      /* Word/User based cracking */
                totalusers,                     /* Total number of accounts */
                lastuser,                       /* Index of last user tested */
                r_accnum,                       /* Restore index of account */
                updn,                           /* Upper/lowercase testing? */
                backwards,                      /* Backwards testing? */
                itest,                          /* A-Z, a-z, 0-9 testing? */
                funnychar,                      /* ^A-^Z/ESC/SPACE testing? */
                login,                          /* Login name testing? */
                gecos,                          /* GECOS field testing? */
                output,                         /* Output to console? */
                hog_resources,                  /* Hog resources? */
                suffixes,                       /* Any suffixes enables? */
                suffix[10],                     /* 0-9 suffix testing? */
                sameword;                       /* check if same guess */

#if defined(__TURBO)
unsigned _stklen = 8192;                        /* 8k stack for Turbo C */
#endif

/*=[ Include XFDES Encryption Routines ]=====================================*/

#include "xfdes.c"

/*===========================================================================*/

/*
**    Function: void initvars(void)
** Description: initialize global variables
*/

void initvars()
{
    register int i;

    output=1;
    cracktype=WORDS;
    timer=0;
    combinations=0;
    updn=0;
    backwards=0;
    hog_resources=0;
    itest=0;
    login=0;
    gecos=0;
    totalusers=0;
    lastuser=0;
    for(i=0; i<10; i++)
        suffix[i]=0;
    suffixes=0;
    funnychar=0;
    r_accnum=(-1);
    passwordfile[0]=0;
    wordfile[0]=0;
    validfile[0]=0;
    restorefile[0]=0;
    errorcode[0]=0;
    lastword[0]=0;
    r_account[0]=0;
    r_word[0]=0;
    sameword=0;
}

/*===========================================================================*/

/*
**    Function: void outstr(char *str)
** Description: output <str> to stdout
**      Return: none
*/

void outstr(str)
    char *str;
{
    write(1, str, strlen(str));
}

/*===========================================================================*/

/*
**    Function: void showguess(char *str)
** Description: output <str> (current guess) to stdout if output is allowed
**      Return: none
*/

void showguess(str)
    char *str;
{
    char s[41];

    if (output) {
        sprintf(s, "\n%-8s ", str);
        outstr(s);
     }
}

/*===========================================================================*/

/*
**    Function: void showstr(char *str)
** Description: output <str> to stdout if output is allowed
**      Return: none
*/

void showstr(str)
    char *str;
{
    if (output)
        outstr(str);
}

/*===========================================================================*/

/*
**    Function: char lowchar(char c)
** Description: convert <c> to lowercase
**      Return: lowercase version of <c>, otherwise just <c>
*/

char lowchar(c)
    char c;
{
    return((c>='A') && (c<='Z') ? c+32 : c);
}

/*===========================================================================*/

/*
**    Function: char *lowcase(char *str)
** Description: convert all characters in <str> to lowercase
**      Return: lowercase version of <str>
*/

char *lowcase(str)
    char *str;
{
    register int i;
    char s[41];

/*  for (i=0; str[i]; i++)
        s[i]=lowchar(str[i]); */
    for (i=0; (*str); i++)
        s[i]=lowchar(*str++);
    s[i]=0;
    return(s);
}

/*===========================================================================*/

/*
**    Function: char upchar(char c)
** Description: convert <c> to uppercase
**      Return: uppercase version of <c>, otherwise just <c>
*/

char upchar(c)
    char c;
{
    return((c>='a') && (c<='z') ? c-32 : c);
}

/*===========================================================================*/

/*
**    Function: char *upcase(char *str)
** Description: convert all characters in <str> to uppercase
**      Return: uppercase version of <str>
*/

char *upcase(str)
    char *str;
{
    register int i;
    char s[41];

/*    for (i=0; str[i]; i++)
        s[i]=upchar(str[i]); */
    for (i=0; (*str); i++)
        s[i]=upchar(*str++);
    s[i]=0;
    return(s);
}

/*===========================================================================*/

/*
**    Function: char *reverse(char *str)
** Description: reverse characters in <str>
**      Return: reverse of <str>
*/

char *reverse(str)
    char *str;
{
    register int i;
    char s[41], *st;

    if ((str) && (str[0])) {
        st=str;
        for(; (*st); st++)
            ;
        for(i=0, st--; (st!=str); i++)
            s[i]=(*st--);
        s[i]=(*st);
        s[i+1]=0;
    }
    else
        s[0]=0;
    return(s);
}

/*===========================================================================*/

/*
**    Function: void kc_exit(int code)
** Description: exit kc with exit code <code>
**      Return: none
*/

void kc_exit(code)
    int code;
{
    char s[81];

    if (kc)
        free(kc);
    if (code) {
        if (code==-1) {
            printf("\n\n");
            perror(errorcode);
        }
        printf("\n%s: abnormal program termination\n", progname);
        exit(1);
    }
    else {
        sprintf(s, "\n\n%s, end of session.\n", errorcode);
        showstr(s);
        exit(0);
    }
}

/*===========================================================================*/

/*
**    Function: int openvalid(void)
** Description: open [validfile] for writing
**      Return: 0 upon normal operation, -1 upon error
*/

int openvalid()
{
    vf=fopen(validfile, "a");
    if (!vf) {
        fclose(gf);
        return(-1);
    }
    fprintf(vf, "\n===================================================================");
    fprintf(vf, "\nKiller Cracker v7.00 -*- By Doctor Dissector -*- Copyright (C) 1991");
    fprintf(vf, "\n-------------------------------------------------------------------");
    fprintf(vf, "\nPasswordfile: %s ", passwordfile);
    fprintf(vf, "\n    Wordfile: %s", wordfile);
    fprintf(vf, "\n-------------------------------------------------------------------");
    return(0);
}

/*===========================================================================*/

/*
**    Function: int openwords(void)
** Description: open [wordfile] for reading
**      Return: 0 upon normal operation, -1 upon error
*/

int openwords()
{
    gf=fopen(wordfile, "r");
    return(!gf ? -1 : 0);
}

/*===========================================================================*/

/*
**    Function: void closevalid(time_t elapsed, int aborted)
** Description: write session data to [validfile] and close
**      Return: none
*/

void closevalid(elapsed, aborted)
    time_t elapsed;
    int aborted;
{
    double performance;

    if (elapsed<1)
        elapsed=1;
    fprintf(vf,"\n-------------------------------------------------------------------");
    if (aborted) {
        if (login)
            strcpy(lastword, "Logins");
        else if (gecos)
            strcpy(lastword, "Gecos");
        else if (cracktype==WORDS) {
            if (itest)
                strcpy(lastword, "a-z, A-Z, 0-9");
            else if (funnychar)
                strcpy(lastword, "^A-^Z, ESC, SPACE");
         }
        if ((login) || (gecos) || (cracktype==WORDS))
            fprintf(vf, "\n*** Cracking aborted, word: %s", lastword);
        else
            fprintf(vf, "\n*** Cracking aborted, account: %s", kc[lastuser].login);
        fprintf(vf, "\n-------------------------------------------------------------------");
    }
    performance=(double)combinations/elapsed;
    fprintf(vf, "\nSession Total: Encryption/Comparisions: %lu", combinations);
    fprintf(vf, "\nSession Total: Time Elapsed In Seconds: %lu", elapsed);
    fprintf(vf, "\nSession Efficiency: Encryptions/Second: %.2f", performance);
    fprintf(vf, "\n===================================================================");
    fclose(vf);
}

/*===========================================================================*/

/*
**    Function: void closeall(time_t elapsed)
** Description: initiate closing of [validfile] and [wordfile]
**      Return: none
*/

void closeall(elapsed)
    time_t elapsed;
{
    closevalid(elapsed, 0);
    fclose(gf);
}

/*===========================================================================*/

/*
**    Function: void foundvalid(int un, char *dpw)
** Description: record valid account information
**      Return: none
*/

void foundvalid(un, dpw)
    int un;
    char *dpw;
{
    char s[81];

    fprintf(vf, "\nAccount: %-12s  Password: %-10s  UID: %-5d  GID: %d",
        kc[un].login, dpw, kc[un].uid, kc[un].gid);
    fflush(vf);
    sprintf(s, "\n>>>>>>>>>> Account: %-12s  Password: %-10s  UID: %-5d  GID: %d\n",
        kc[un].login, dpw, kc[un].uid, kc[un].gid);
    showstr(s);
}

/*===========================================================================*/

/*
**    Function: void foundinactive(int un)
** Description: show inactive account information
**      Return: none
*/

void foundinactive(un)
    int un;
{
    char s[81];

    sprintf(s, "\n>>>>>>>>>> Inactive account: %-12s  UID: %-5d  GID: %d\n",
        kc[un].login, kc[un].uid, kc[un].gid);
    showstr(s);
}

/*===========================================================================*/

/*
**    Function: char *getfield(char *fields, int gecosfield)
** Description: retrieve next field from <fields> of type <gecosfield>
**      Return: next field from <fields> of type <gecosfield>
*/

char *getfield(fields, gecosfield)
    char *fields;
    int gecosfield;
{
    register int i;
    char curfield[50], newfields[200];

    if (gecosfield) {
        for(i=0; (i<200) && (!strchr(":, ", fields[i])); i++)
            curfield[i]=fields[i];
    }
    else {
        for(i=0; (i<200) && (fields[i]!=':'); i++)
            curfield[i]=fields[i];
    }
    curfield[i]=0;
    strcpy(newfields, &fields[i+1]);
    if (fields[i]==':')
        fields[0]=0;
    strcpy(fields, newfields);
    return(curfield);
}

/*===========================================================================*/

/*
**    Function: int getpw(void)
** Description: reads [passwordfile] and loads data into [kc] data structures
**      Return: <u> (number of accounts) upon normal operation, -1 if an error
**              occurs opening [passwordfile] for reading, -2 if an error
**              occurs during allocation of memory for [kc]
*/

int getpw()
{
    register int i, u;
    char s[200], sw[200];
    FILE *f;

    f=fopen(passwordfile, "r");
    if (!f)
        return(-1);
    for(u=0; (fgets(s, 199, f)); u++)
        ;
    fclose(f);
    kc=(kc_struct *)malloc(u*sizeof(kc_struct));
    if (!kc)
        return(-2);
    f=fopen(passwordfile, "r");
    if (!f)
        return(-1);
    for(i=0; i<u; i++) {
        fgets(s, 199, f);
        strcpy(sw, getfield(s, 0));
        sw[12]=0;
        strcpy(kc[i].login, sw);
        if ((cracktype==USERS) && (r_accnum==(-1))) {
            if (!strcmp(kc[i].login, r_account))
                r_accnum=i;
        }
        strcpy(sw, getfield(s, 0));
        sw[13]=0;
        strcpy(kc[i].epw, sw);
        strcpy(sw, getfield(s, 0));
        kc[i].uid=atoi(sw);
        strcpy(sw, getfield(s, 0));
        kc[i].gid=atoi(sw);
        do {
            strcpy(sw, getfield(s, 1));
        } while((sw[0]) && (sw[1]=='.'));
        if (sw[0]) {
            sw[14]=0;
            strcpy(kc[i].gecos1, sw);
            strcpy(s, sw);
            do {
                strcpy(sw, getfield(s, 1));
            } while((sw[0]) && (sw[1]=='.'));
            if (sw[0]) {
                sw[14]=0;
                strcpy(kc[i].gecos2, sw);
            }
            else
                kc[i].gecos2[0]=0;
        }
        else {
            kc[i].gecos1[0]=0;
            kc[i].gecos2[0]=0;
         }
        if ((kc[i].epw[0]=='*') ||
            (!strcmp(upcase(kc[i].epw), "NOLOGIN")) ||
            (!strcmp(upcase(kc[i].epw), "INVALID")) ||
            (!strcmp(upcase(kc[i].epw), "INACTIVE"))) {
            foundinactive(i);
            kc[i].cracked=1;
        }
        else if (!kc[i].epw[0]) {
            foundvalid(i, "(blank)");
            kc[i].cracked=1;
        }
        else
            kc[i].cracked=0;
    }
    fclose(f);
    return(u);
}

/*===========================================================================*/

/*
**    Function: int getnextsuffix(int curtype)
** Description: determines next numeric suffix to append to guess
**      Return: SUFFIX0-SUFFIX9 or DONE if no more suffixes are to be tested
*/

int getnextsuffix(curtype)
    int curtype;
{
    register int i;

    if (curtype<SUFFIX0)
        curtype=SUFFIX0-1;
    for(i=curtype+1; (i<=SUFFIX9) && (!suffix[i-SUFFIX0]); i++)
        ;
    return(i<=SUFFIX9 ? i : DONE);
}

/*===========================================================================*/

/*
**    Function: char *allsuffix(void)
** Description: creates a string which lists the numeric suffixes to append
**      Return: <s> containing the suffix list
*/

char *allsuffix()
{
    int i, j;
    char s[31];

    s[0]=0;
    if (suffixes) {
        for(i=0, j=0; i<10; i++) {
            if (suffix[i])
                s[j++]=('0'+i);
        }
        s[j]=0;
    }
    return(s);
}

/*===========================================================================*/

/*
**    Function: void addsuffix(int sufnum)
** Description: adds numeric suffix <sufnum> to [suffix] list
**      Return: none
*/

void addsuffix(sufnum)
    int sufnum;
{
    suffix[sufnum]=1;
    suffixes=1;
}

/*===========================================================================*/

/*
**    Function: int findtype(int curtype)
** Description: determines the current word combination for current guess
**      Return: combination type of guess, DONE if no more combinations
*/

int findtype(curtype)
    int curtype;
{
    register int newtype;

    if ((updn) && (backwards))
        newtype=((curtype>=LOWBW) ? DONE : curtype+1);
    else if (updn)
        newtype=((curtype>=LOWCASE) ? DONE : curtype+1);
    else if (backwards)
        newtype=((curtype>=BW) ? DONE : BW);
    else newtype=DONE;
    if ((newtype==DONE) && (suffixes))
        newtype=getnextsuffix(curtype);
    return(newtype);
}

/*===========================================================================*/

/*
**    Function: char *makeword(char *str, int wordtype)
** Description: creates the correct combination of the current guess
**      Return: combination of the current guess, <s[0]=0> if combination
**              would be repetitive
*/

char *makeword(str, wordtype)
    char *str;
    int wordtype;
{
    register int i=9, j;
    char s[21];

    switch(wordtype) {
        case NORMAL:
            strcpy(s, str);
            break;
        case UPCASE:
            strcpy(s, upcase(str));
            if (!strcmp(s, str))
                s[0]=0;
            break;
        case LOWCASE:
            strcpy(s, lowcase(str));
            if (!strcmp(s, str))
                s[0]=0;
            break;
        case BW:
            strcpy(s, reverse(str));
            if (!strcmp(s, str))
                s[0]=0;
            break;
        case UPBW:
            strcpy(s, upcase(reverse(str)));
            if (!((strcmp(s, upcase(str))) && (strcmp(s, reverse(str)))))
                s[0]=0;
            break;
        case LOWBW:
            strcpy(s, lowcase(reverse(str)));
            if (!((strcmp(s, lowcase(str))) && (strcmp(s, reverse(str)))))
                s[0]=0;
            break;
        case SUFFIX0: i--;
        case SUFFIX1: i--;
        case SUFFIX2: i--;
        case SUFFIX3: i--;
        case SUFFIX4: i--;
        case SUFFIX5: i--;
        case SUFFIX6: i--;
        case SUFFIX7: i--;
        case SUFFIX8: i--;
        case SUFFIX9:
            j=strlen(str);
            if ((j) && (strlen(str)<8))
                sprintf(s, "%s%d", str, i);
            else
                s[0]=0;
            break;
    }
    s[8]=0;
    return(s);
}

/*===========================================================================*/

/*
**    Function: char *nextword(void)
** Description: retrieves next word from [wordfile]
**      Return: next word in [wordfile], <lastword[0]=0> if no more words
*/

char *nextword()
{
    if (!fgets(lastword, 30, gf))
        lastword[0]=0;
    else {
        lastword[strlen(lastword)-1]=0;
        lastword[12]=0;
    }
    return(lastword);
}

/*===========================================================================*/

/*
**    Function: int testpw(int un, char *dpw)
** Description: actually compares <dpw> (decrypted password, current guess)
**              to the current account's encrypted password
**      Return: 1 if both encrypted passwords match, 0 if not
*/

int testpw(un, dpw)
    int un;
    char *dpw;
{
    lastuser=un;
    combinations++;

#if defined(DEBUGGING)
    char s[41];
    sprintf(s, "/%s", dpw);
    showstr(s);
#endif

    if (!strcmp(kc[un].epw, fcrypt(dpw, kc[un].epw))) {
        kc[un].cracked=1;
        showstr("-");
        foundvalid(un, dpw);
        return(1);
    }
    showstr("-");
    return(0);
}

/*===========================================================================*/

/*
**    Function: void login_testpw(int un, int wordtype)
** Description: does login account name testing
**      Return: none
*/

void login_testpw(un, wordtype)
    int un, wordtype;
{
    char s[11];

    if (!kc[un].cracked) {
        strcpy(s, makeword(kc[un].login, wordtype));
        if (s[0])
            testpw(un, s);
        else
            showstr("*");
    }
    else
        showstr("+");
}

/*===========================================================================*/

/*
**    Function: void gecos_testpw(int un, int wordtype, int field)
** Description: does gecos field testing
**      Return: none
*/

void gecos_testpw(un, wordtype, field)
    int un, wordtype, field;
{
    char s[11];

    if (!kc[un].cracked) {
        if (field==1)
            strcpy(s, makeword(kc[un].gecos1, wordtype));
        else
            strcpy(s, makeword(kc[un].gecos2, wordtype));
        if (s[0])
            testpw(un, s);
        else
            showstr("*");
    }
    else
        showstr("+");
}

/*===========================================================================*/

/*
**    Function: void testfirst(int firsttype)
** Description: initiates login/gecos testing
**      Return: none
*/

void testfirst(firsttype)
    int firsttype;
{
    register int curuser, alldone=0, wordtype=NORMAL;
    char s[11], t[11];

    switch(firsttype) {
        case LOGIN:
            strcpy(s, "Logins");
            break;
        case GECOS1:
            strcpy(s, "1Gecos");
            break;
        case GECOS2:
            strcpy(s, "2Gecos");
            break;
    }
    while (!alldone) {
        strcpy(t, makeword(s, wordtype));
        showguess(t);
        for(curuser=0; curuser<totalusers; curuser++) {
            switch(firsttype) {
                case LOGIN:
                    login_testpw(curuser, wordtype);
                    break;
                case GECOS1:
                    gecos_testpw(curuser, wordtype, 1);
                    break;
                case GECOS2:
                    gecos_testpw(curuser, wordtype, 2);
                    break;
            }
        }
        wordtype=findtype(wordtype);
        if (wordtype==DONE)
            alldone=1;
    }
}

/*===========================================================================*/

/*
**    Function: void itest_testpw(char ichar, char funny)
** Description: tests single characters
**      Return: none
*/

void itest_testpw(ichar, funny)
    char ichar, funny;
{
    register int curuser;
    register char w[2];
    char s[11];

    sameword=0;
    if (funny) {
        if (ichar<27) {
            sprintf(s, "<^%c>", (ichar-1)+'A');
            showguess(s);
        }
        else if (ichar==27)
            showguess("<ESC>");
        else
            showguess("<SPACE>");
    }
    else
        showguess(w);
    sprintf(w, "%c", ichar);
    for(curuser=0; curuser<totalusers; curuser++) {
        if (!kc[curuser].cracked)
            testpw(curuser, w);
        else
            showstr("+");
        sameword=1;
    }
}

/*===========================================================================*/

/*
**    Function: void testitest(void)
** Description: initiates a-z, A-Z, 0-9 character testing
**      Return: none
*/

void testitest()
{
    register char c;

    for(c='a'; c<'{'; c++)
        itest_testpw(c, 0);
    for(c='A'; c<'['; c++)
        itest_testpw(c, 0);
    for(c='0'; c<':'; c++)
        itest_testpw(c, 0);
    sameword=0;
}

/*===========================================================================*/

/*
**    Function: void testfunny(void)
** Description: initiates ^A-^Z, ESC, SPACE testing
**      Return: none
*/

void testfunny()
{
    register char c;

    for(c=1; c<28; c++)
        itest_testpw(c, 1);
    itest_testpw(32, 1);
    sameword=0;
}

/*===========================================================================*/

/*
**    Function: void kc_words(void)
** Description: initiates cracking session by words
**      Return: none
*/

void kc_words()
{
    register int wordtype=NORMAL, curuser;
    char w[13], t[13];

    if (itest)
        testitest();
    itest=0;
    if (funnychar)
        testfunny();
    funnychar=0;
    if (r_word[0]) {
        do {
            strcpy(w, nextword());
        } while((w[0]) && (strcmp(w, r_word)));
    }
    else
        strcpy(w, nextword());
    while(w[0]) {
        while (wordtype!=DONE) {
            strcpy(t, makeword(w, wordtype));
            if (t[0]) {
                showguess(t);
                sameword=0;
                for(curuser=0; curuser<totalusers; curuser++) {
                    if (!kc[curuser].cracked)
                        testpw(curuser, t);
                    else
                        showstr("+");
                    sameword=1;
                }
            }
            wordtype=findtype(wordtype);
        }
        strcpy(w, nextword());
        wordtype=NORMAL;
    }
}

/*===========================================================================*/

/*
**    Function: void kc_users(void)
** Description: initiates cracking session by users
**      Return: none
*/

void kc_users()
{
    register int c, curuser, wordtype=NORMAL;
    char w[13], t[13];
    int i;

    i=(r_accnum==-1 ? 0 : r_accnum);
    for(curuser=i; curuser<totalusers; curuser++) {
        if (!kc[curuser].cracked) {
            showguess(kc[curuser].login);
            if (itest) {
                for(c='a'; (c<'{') && (!kc[curuser].cracked); c++) {
                    sprintf(t, "%c", c);
                    testpw(curuser, t);
                }
                for(c='A'; (c<'[') && (!kc[curuser].cracked); c++) {
                    sprintf(t, "%c", c);
                    testpw(curuser, t);
                }
                for(c='0'; (c<':') && (!kc[curuser].cracked); c++) {
                    sprintf(t, "%c", c);
                    testpw(curuser, t);
                }
            }
            if (funnychar) {
                for(c=1; (c<28) && (!kc[curuser].cracked); c++) {
                    sprintf(t, "%c", c);
                    testpw(curuser, t);
                }
                sprintf(t, "%c", 32);
                testpw(curuser, t);
            }
            strcpy(w, nextword());
            while((w[0]) && (!kc[curuser].cracked)) {
                while((wordtype!=DONE) && (!kc[curuser].cracked)) {
                    strcpy(t, makeword(w, wordtype));
                    if (t[0])
                        testpw(curuser, t);
                    else showstr("*");
                    wordtype=findtype(wordtype);
                }
                strcpy(w, nextword());
                wordtype=NORMAL;
            }
            fclose(gf);
            gf=fopen(wordfile, "r");
        }
    }
}

/*===========================================================================*/

/*
**    Function: void crack(void)
** Description: backgrounds process, initiates all cracking
**      Return: none
*/

void crack()
{
    char s[40];
    time_t temp;

#if defined(__SYSV) || defined(__BSD)
    if (!output) {
        if (isatty(0)) {
            close(0);
            close(1);
            close(2);
            if (fork())
                exit(0);
        }
        else {
            close(0);
            close(1);
            close(2);
        }
    }
#endif

    sprintf(s,"\nCracking %d accounts...\n", totalusers);
    showstr(s);
    timer=time(&temp);
    if (login)
        testfirst(LOGIN);
    login=0;
    if (gecos) {
        testfirst(GECOS1);
        testfirst(GECOS2);
    }
    gecos=0;
    switch(cracktype) {
        case USERS:
            kc_users();
            break;
        case WORDS:
            kc_words();
            break;
    }
    closeall(time(&temp)-timer);
    strcpy(errorcode, "Cracking complete");
}

/*===========================================================================*/

/*
**    Function: void getstat(void)
** Description: prompts for files unspecified by the command line
**      Return: none
*/

void getstat()
{
    printf("\n");
    if (!passwordfile[0]) {
        printf("Passwordfile: ");
        gets(passwordfile);
    }
    if (!wordfile[0]) {
        printf("Wordfile    : ");
        gets(wordfile);
    }
    if (!validfile[0]) {
        printf("Validfile   : ");
        gets(validfile);
    }
}

/*===========================================================================*/

/*
**    Function: void printfiles(void)
** Description: prints current filenames specified
**      Return: none
*/

void printfiles()
{
    printf("\nPasswordfile : %s", passwordfile);
    printf("\nWordfile     : %s", wordfile);
    printf("\nValidfile    : %s\n", validfile);
}

/*===========================================================================*/

/*
**    Function: void printstat(void)
** Description: prints current options specified
**      Return: none
*/

void printstat()
{
    char s[41];

    switch(cracktype) {
        case WORDS:
            printf("\n* Testing based on words");
            break;
        case USERS:
            printf("\n* Testing based on users");
            break;
    }
    printf("\n* Normal output to console");
    if (login)
        printf("\n* Test login names as passwords");
    if (gecos)
        printf("\n* Test GECOS field names as passwords");
    if (itest)
        printf("\n* a-z, A-Z, 0-9 single character testing");
    if (funnychar)
        printf("\n* ^A-^Z, ESC, SPACE funny character testing");
    if (updn)
        printf("\n* Uppercase & lowercase testing");
    if (backwards)
        printf("\n* Backwards word testing");
    if (suffixes) {
        strcpy(s, allsuffix());
        printf("\n* Append numeric suffix: %s", s);
    }
    if (hog_resources)
        printf("\n* Attempt to hog system resources");
    printf("\n");
}

/*===========================================================================*/

/*
**    Function: char *getoptions(void)
** Description: creates a string including session flags
**      Return: string containing session flags
*/

char *getoptions()
{
    char flags[81];
    int i;

    strcpy(flags, allsuffix());
    i=strlen(flags);
    if (backwards)
        flags[i++]='b';
    if (updn)
        flags[i++]='c';
    if (!output)
        flags[i++]='o';

#if defined(__BSD)
    if (hog_resources)
        flags[i++]='h';
#endif

    if (cracktype==USERS)
        flags[i++]='u';
    flags[i]=0;
    return(flags);
}

/*===========================================================================*/

/*
**    Function: void saveoptions(void)
** Description: saves current session information into [restorefile]
**      Return: none
*/

void saveoptions()
{
    FILE *rf;

    rf=fopen("restore", "w");
    if (!rf) {
        strcpy(errorcode, "restore");
        kc_exit(-1);
    }
    fprintf(rf, "Passwordfile=%s\n", passwordfile);
    fprintf(rf, "Wordfile=%s\n", wordfile);
    fprintf(rf, "Validfile=%s\n", validfile);
    fprintf(rf, "Flags=%s\n", getoptions());
    if (cracktype==USERS)
        fprintf(rf, "Lastaccount=%s\n", kc[lastuser].login);
    else {
        if ((login) || (gecos) || (itest) || (funnychar))
            strcpy(lastword, nextword());
        fprintf(rf, "Lastword=%s", lastword);
    }
    fclose(rf);
}

/*===========================================================================*/

/*
**    Function: char *getnexttoken(char *s, char c)
** Description: retrieve next token from <s> separated by <c>
**      Return: next token in <s>
*/

char *getnexttoken(s, c)
    char *s, c;
{
    register int i, j;
    char token[MAX_FILENAME];

    for(i=0; s[i]!=c; i++)
        ;
    i++;
    for(j=0; (s[i]) && (s[i]!='\r') && (s[i]!='\n'); i++, j++)
        token[j]=s[i];
    token[j]=0;
    return(token);
}

/*===========================================================================*/

/*
**    Function: char *getfirsttoken(char *s, char c)
** Description: retrieve first token from <s> separated by <c>
**      Return: first token in <s>
*/

char *getfirsttoken(s, c)
    char *s, c;
{
    register int i;
    char token[MAX_FILENAME];

    for(i=0; ((token[i]=s[i])!=c); i++)
        ;
    token[i]=0;
    return(token);
}

/*===========================================================================*/

/*
**    Function: void printtitle(void)
** Description: prints kc version and copyright
**      Return: none
*/

void printtitle()
{
    printf("\nKiller Cracker v7.00 (6/1/91)");
    printf("\nCopyright (C) 1991, By Doctor Dissector\n");
}

/*===========================================================================*/

/*
**    Function: void readoptions(char *options)
** Description: reads and initializes command line flags/restorefile flags
**      Return: none
*/

void readoptions(options)
    char *options;
{
    if (strchr(options, '0'))
        addsuffix(0);
    if (strchr(options, '1'))
        addsuffix(1);
    if (strchr(options, '2'))
        addsuffix(2);
    if (strchr(options, '3'))
        addsuffix(3);
    if (strchr(options, '4'))
        addsuffix(4);
    if (strchr(options, '5'))
        addsuffix(5);
    if (strchr(options, '6'))
        addsuffix(6);
    if (strchr(options, '7'))
        addsuffix(7);
    if (strchr(options, '8'))
        addsuffix(8);
    if (strchr(options, '9'))
        addsuffix(9);
    if (strchr(options, 'B'))
        backwards=1;
    if (strchr(options, 'C'))
        updn=1;
    if (strchr(options, 'F'))
        funnychar=1;
    if (strchr(options, 'G'))
        gecos=1;
    if (strchr(options, 'H'))
        hog_resources=1;
    if (strchr(options, 'L'))
        login=1;
    if (strchr(options, 'O'))
        output=0;
    if (strchr(options, 'S'))
        itest=1;
    if (strchr(options, 'U'))
        cracktype=USERS;
}

/*===========================================================================*/

/*
**    Function: int restore(void)
** Description: restores session saved in [restorefile]
**      Return: 0 upon normal operation, -1 if an error occurs opening
**              [restorefile] for reading, 1 if the identifier field
**              is invalid
*/

int restore()
{
    FILE *rf;
    char s[MAX_FILENAME];

    rf=fopen(restorefile, "r");
    if (!rf) {
        strcpy(errorcode, restorefile);
        kc_exit(-1);
    }
    while(fgets(s, MAX_FILENAME, rf)) {
        if (strlen(s)<5)
            break;
        else if (!strcmp(upcase(getfirsttoken(s, '=')), "PASSWORDFILE"))
            strcpy(passwordfile, getnexttoken(s, '='));
        else if (!strcmp(upcase(getfirsttoken(s, '=')), "WORDFILE"))
            strcpy(wordfile, getnexttoken(s, '='));
        else if (!strcmp(upcase(getfirsttoken(s, '=')), "VALIDFILE"))
            strcpy(validfile, getnexttoken(s, '='));
        else if (!strcmp(upcase(getfirsttoken(s, '=')), "FLAGS"))
            readoptions(upcase(getnexttoken(s, '=')));
        else if (!strcmp(upcase(getfirsttoken(s, '=')), "LASTACCOUNT"))
            strcpy(r_account, getnexttoken(s, '='));
        else if (!strcmp(upcase(getfirsttoken(s, '=')), "LASTWORD"))
            strcpy(r_word, getnexttoken(s, '='));
        else
            return(1);
    }
    fclose(rf);
    if (output)
        printtitle();
    if ((!passwordfile[0]) || (!wordfile[0]) || (!validfile[0]))
        return(1);
    if (((cracktype==WORDS) && (!r_word[0])) ||
        ((cracktype==USERS) && (!r_account[0])))
        return(1);
    if (output) {
        if ((cracktype==WORDS) && (r_word[0]))
            printf("\n*** Restoring, Word: %s\n", r_word);
        else if ((cracktype==USERS) && (r_account[0]))
            printf("\n*** Restoring, Account: %s\n", r_account);
        printfiles();
        printstat();
    }
    return(0);
}

/*===========================================================================*/

/*
**    Function: void/int handler(void)
** Description: interrupt handler for aborting crack sessions
**      Return: none/0
*/

#ifndef __ANSI
#if defined(__BSD) || defined(__SYSV)
int handler()
#else
void handler()
#endif

{
    time_t temp;

#if defined(__SYSV) || defined(__BSD)
    signal(SIGQUIT, SIG_IGN);
    signal(SIGINT, SIG_IGN);
#else
    signal(SIGINT, SIG_IGN);
#endif

    closevalid(time(&temp)-timer, 1);
    saveoptions();
    fclose(gf);
    strcpy(errorcode, "Cracking aborted");
    kc_exit(0);

#if defined(__BSD) || defined(__SYSV)
    return(0);
#endif

}

/*===========================================================================*/

/*
**    Function: void setsignals(void)
** Description: initializes interrupts and interrupt handler
**      Return: none
*/

void setsignals()
{

#if defined(__TURBO) || defined(__MICROSOFT)
    signal(SIGINT, handler);
#else
    signal(SIGINT, handler);
    signal(SIGQUIT, handler);
    signal(SIGHUP, SIG_IGN);
#endif

}
#endif

/*===========================================================================*/

/*
**    Function: void maxcpulimit(void)
** Description: maximizes cpu limit if limit is not currently set to max
**      Return: none
*/

#if defined(__BSD)
void maxcpulimit()
{
    struct rlimit r;

    getrlimit(RLIMIT_CPU, &r);
    r.rlim_cur=r.rlim_max;
    setrlimit(RLIMIT_CPU, &r);
}
#endif

/*===========================================================================*/

/*
**    Function: int initall(void)
** Description: initiates setup procedures for crack session
**      Return: 0 if no errors occur, -1 if an error occurs
*/

int initall()
{

#ifndef __ANSI
    setsignals();
#endif

    if (openwords()==-1) {
        strcpy(errorcode, wordfile);
        return(-1);
    }
    if (openvalid()==-1) {
        strcpy(errorcode, validfile);
        fclose(gf);
        return(-1);
    }
    totalusers=getpw();
    if (totalusers<0) {
        if (totalusers==-1)
            strcpy(errorcode, passwordfile);
        else if (totalusers==-2)
            strcpy(errorcode, "malloc failed");
        else kc_exit(1);
        return(-1);
    }
    if ((cracktype==USERS) && (r_accnum==-1) && (restorefile[0])) {
        fclose(gf);
        printf("\n%s: invalid account name: %s\n", progname, r_account);
        kc_exit(1);
    }

#if defined(__BSD)
    if (hog_resources)
        maxcpulimit();
#endif

    init_des();
    return(0);
}

/*===========================================================================*/

/*
**    Function: void printusage(void)
** Description: prints usage information
**      Return: none
*/

void printusage()
{

#if defined(__BSD)
    printf("\nUsage: kc [-?0123456789bcfghlosu] [-p[:]<file>] [-w[:]<file>] [-v[:]<file>]");
#else
    printf("\nUsage: kc [-?0123456789bcfglosu] [-p[:]<file>] [-w[:]<file>] [-v[:]<file>]");
#endif

    printf("\n       kc [-r[:]<file>]\n");
    printf("\nFiles: -p /etc/passwd file    -w word guess file    -v valid account file");
    printf("\n       -r restore file\n");
    printf("\nFlags: -? explain usage       -# numeric suffixes   -b test backwards");
    printf("\n       -c test up/low cases   -f test funny chars   -g test GECOS fields");

#if defined(__BSD)
    printf("\n       -h hog resources       -l test login names   -o suppress output");
    printf("\n       -s test single chars   -u user based crack\n");
#else
    printf("\n       -l test login names    -o suppress output    -s test single chars");
    printf("\n       -u user based crack\n");
#endif

    printf("\nPurpose: Un*x /etc/passwd brute force password cracker.\n");
}

/*===========================================================================*/

/*
**    Function: void main(int argc, char **argv)
** Description: main function
**      Return: none
*/

void main(argc, argv)
    int argc;
    char **argv;
{
    char s[MAX_FILENAME];
    int i, restoring, colon;

    initvars();
    strcpy(progname, argv[0]);
    for (i=1, restoring=0; (i<argc) && (!restoring); i++) {
        strcpy(s, argv[i]);
        if ((s[0]=='-') || (s[0]=='/')) {
            switch(upchar(s[1])) {
                case 'P':
                    colon=(s[2]==':' ? 3 : 2);
                    strcpy(passwordfile, &s[colon]);
                    break;
                case 'R':
                    initvars();
                    colon=(s[2]==':' ? 3 : 2);
                    strcpy(restorefile, &s[colon]);
                    if (!restorefile[0])
                        strcpy(restorefile, "restore");
                    restoring=1;
                    break;
                case 'V':
                    colon=(s[2]==':' ? 3 : 2);
                    strcpy(validfile, &s[colon]);
                    break;
                case 'W':
                    colon=(s[2]==':' ? 3 : 2);
                    strcpy(wordfile, &s[colon]);
                    break;
                case '?':
                    printtitle();
                    printusage();
                    kc_exit(1);
                    break;
                case '0':
                case '1':
                case '2':
                case '3':
                case '4':
                case '5':
                case '6':
                case '7':
                case '8':
                case '9':
                case 'B':
                case 'C':
                case 'F':
                case 'G':

#if defined(__BSD)
                case 'H':
#endif

                case 'L':
                case 'O':
                case 'S':
                case 'U':
                    readoptions(upcase(&s[1]));
                    break;
                default :
                    printtitle();
                    printusage();
                    printf("\n%s: invalid arguments: %s\n", progname, s);
                    kc_exit(1);
                    break;
            }
        }
    }
    if (restoring) {
        if (restore()) {
            printf("\n%s: Invalid restorefile: %s", progname, restorefile);
            kc_exit(1);
        }
    }
    else if (output) {
        printtitle();
        if ((!passwordfile[0]) || (!wordfile[0]) || (!validfile[0]))
            getstat();
        else printfiles();
        printstat();
    }
    if ((passwordfile[0]) && (wordfile[0]) && (validfile[0])) {
        if (initall()==-1)
            kc_exit(-1);
        crack();
        kc_exit(0);
    }
    else {
        printf("\n%s: invalid command line arguments\n", progname);
        kc_exit(1);
    }
}
